"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const loader_utils_1 = require("loader-utils");
const utils_1 = require("../utils");
const loader = function (source, sourceMap) {
    if (this.cacheable) {
        this.cacheable();
    }
    const createDTSFile = utils_1.makeDTSFile(loader_utils_1.getOptions(this));
    const callback = this.async();
    if (callback === undefined) {
        return;
    }
    createDTSFile(this.resourcePath, source.toString())
        .then(() => callback(null, source, sourceMap))
        .catch((err) => callback(err));
};
exports.default = loader;
//# sourceMappingURL=webpack-loader.js.map