"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModuleTokensWithSelector = void 0;
const lodash_1 = __importDefault(require("lodash"));
const css_selector_tokenizer_1 = __importDefault(require("css-selector-tokenizer"));
function getModuleTokensWithSelector(selector, options) {
    options = lodash_1.default.defaults(options, { mode: 'local', camelCase: false });
    return lodash_1.default.chain(css_selector_tokenizer_1.default.parse(selector).nodes)
        .flatMap((node) => getTokens(node, { mode: options === null || options === void 0 ? void 0 : options.mode }, []))
        .map(options.camelCase ? lodash_1.default.camelCase : lodash_1.default.identity)
        .value();
}
exports.getModuleTokensWithSelector = getModuleTokensWithSelector;
const getTokens = (node, options, tokens) => {
    if (node.name === 'local' || node.name === 'global') {
        if (node.type === 'pseudo-class') {
            options.mode = node.name;
        }
        if (node.type === 'nested-pseudo-class') {
            return getTokens(node.nodes[0], { mode: node.name }, tokens);
        }
    }
    if (options.mode === 'local' &&
        (node.type === 'id' || node.type === 'class')) {
        tokens = lodash_1.default.compact(lodash_1.default.union(tokens, [node.name]));
    }
    // @ts-ignore
    if (lodash_1.default.isArray(node.nodes)) {
        // @ts-ignore
        return lodash_1.default.flatMap(node.nodes, (node) => getTokens(node, options, tokens));
    }
    return tokens;
};
//# sourceMappingURL=modules-selector.js.map