"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModuleTokens = void 0;
const lodash_1 = __importDefault(require("lodash"));
const postcss_1 = __importDefault(require("postcss"));
const postcss_load_config_1 = __importDefault(require("postcss-load-config"));
const modules_selector_1 = require("./modules-selector");
function getModuleTokens(source, from, options) {
    return __awaiter(this, void 0, void 0, function* () {
        let tokens = [];
        const walkTokensPlugin = (css) => {
            css.walkRules((node) => {
                const newTokens = lodash_1.default.flatMap(node.selectors, (selector) => modules_selector_1.getModuleTokensWithSelector(selector, options));
                tokens = lodash_1.default.compact(lodash_1.default.union(tokens, newTokens));
            });
        };
        const config = yield getConfig();
        config.options.from = from || config.file;
        yield postcss_1.default(config.plugins)
            .use(walkTokensPlugin)
            .process(source, config.options);
        return tokens;
    });
}
exports.getModuleTokens = getModuleTokens;
function getConfig() {
    const defaults = {
        file: undefined,
        options: { from: undefined },
        plugins: [],
    };
    return postcss_load_config_1.default().catch(lodash_1.default.constant(defaults));
}
//# sourceMappingURL=modules.js.map