"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypeHint = void 0;
const lodash_1 = __importDefault(require("lodash"));
const typescript_1 = __importDefault(require("typescript"));
const StringKeyword = typescript_1.default.createKeywordTypeNode(typescript_1.default.SyntaxKind.StringKeyword);
const IndexSignature = typescript_1.default.createIndexSignature(undefined, undefined, typescript_1.default.createNodeArray([
    typescript_1.default.createParameter(undefined, undefined, undefined, 'name', undefined, StringKeyword),
]), StringKeyword);
function createTypeHint(tokens) {
    if (lodash_1.default.isEmpty(tokens)) {
        return '';
    }
    const Locals = lodash_1.default.chain(tokens)
        .sortBy()
        .union()
        .map((token) => typescript_1.default.createPropertySignature(undefined, typescript_1.default.createLiteral(token), undefined, StringKeyword, undefined))
        .concat(IndexSignature)
        .thru((members) => typescript_1.default.createInterfaceDeclaration(undefined, undefined, typescript_1.default.createIdentifier('ILocals'), undefined, undefined, members))
        .value();
    const localsName = typescript_1.default.createIdentifier('locals');
    const locals = typescript_1.default.createVariableStatement([typescript_1.default.createToken(typescript_1.default.SyntaxKind.DeclareKeyword)], typescript_1.default.createVariableDeclarationList([
        typescript_1.default.createVariableDeclaration(localsName, typescript_1.default.createTypeReferenceNode(Locals.name, undefined)),
    ], typescript_1.default.NodeFlags.Const));
    const file = typescript_1.default.createSourceFile('', '', typescript_1.default.ScriptTarget.Latest);
    file.statements = typescript_1.default.createNodeArray([
        Locals,
        locals,
        typescript_1.default.createExportAssignment(undefined, undefined, true, localsName),
    ]);
    const lines = [
        '/* eslint-disable */',
        '/* ignore jslint start */',
        '// tslint:disable',
        '// jscs:disable',
        '// jshint ignore: start',
        '// prettier-ignore',
        '',
        '// The code is automated generator',
        '// https://github.com/NiceLabs/typed-css-modules',
        typescript_1.default.createPrinter().printFile(file),
    ];
    return lines.join('\n');
}
exports.createTypeHint = createTypeHint;
//# sourceMappingURL=type-hint.js.map