"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_dedent_1 = __importDefault(require("ts-dedent"));
const chai_1 = require("chai");
require("mocha");
const type_hint_1 = require("./type-hint");
describe('type-hint generator', () => {
    it('tokens', () => {
        const hint = type_hint_1.createTypeHint(['c', 'b', 'a']);
        const result = ts_dedent_1.default `
        /* eslint-disable */
        /* ignore jslint start */
        // tslint:disable
        // jscs:disable
        // jshint ignore: start
        // prettier-ignore

        // The code is automated generator
        // https://github.com/NiceLabs/typed-css-modules
        interface ILocals {
            "a": string;
            "b": string;
            "c": string;
            [name: string]: string;
        }
        declare const locals: ILocals;
        export = locals;

        `;
        chai_1.expect(result).to.eql(hint);
    });
});
//# sourceMappingURL=type-hint.spec.js.map