#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeDTSFile = void 0;
const fs_1 = require("fs");
const lodash_1 = __importDefault(require("lodash"));
const modules_1 = require("./modules");
const type_hint_1 = require("./type-hint");
exports.makeDTSFile = (options) => (filePath, source) => __awaiter(void 0, void 0, void 0, function* () {
    const target = `${filePath}.d.ts`;
    try {
        const payload = source || (yield fs_1.promises.readFile(filePath, 'utf8'));
        const tokens = yield modules_1.getModuleTokens(payload, filePath, options);
        if (!lodash_1.default.isEmpty(tokens)) {
            yield fs_1.promises.writeFile(target, type_hint_1.createTypeHint(tokens));
            return;
        }
        if (yield fs_1.promises.stat(target)) {
            yield fs_1.promises.unlink(target);
        }
    }
    catch (e) {
        // ignore error
    }
});
//# sourceMappingURL=utils.js.map